p = 3
F = GF(3)
Rx.<x> = PolynomialRing(F)
f = x^3 - x
m = 2
C = superelliptic(f, m)
xx = C.x.expansion_at_infty(prec = 200)
yy = C.y.expansion_at_infty(prec = 200)
r = f.degree()
delta = GCD(m, r)
R = r/delta
M = m/delta
print(yy^2 == f(x = xx))
print(xx.valuation() == -M, yy.valuation() == -R)