p = 5
m = 2
F = GF(p^2, 'a')
a = F.gens()[0]
Rx.<x> = PolynomialRing(F)
f = x^3 + x^2 + 1
C_super = superelliptic(f, m)
Rxy.<x, y> = PolynomialRing(GF(p), 2)
fArS1 = superelliptic_function(C_super, y*x)
fArS2 = superelliptic_function(C_super, y*x^2)
fArS3 = superelliptic_function(C_super, y + x)
AS1 = as_cover(C_super, [fArS1, fArS2, fArS3], prec=150)
AS2 = as_cover(C_super, [fArS2, fArS3, fArS1], prec=150)
print(AS1.genus() == AS2.genus())
##################
p = 5
m = 2
Rx.<x> = PolynomialRing(GF(p))
f = x^3 + x^2 + 1
C_super = superelliptic(f, m)
Rxy.<x, y> = PolynomialRing(GF(p), 2)
fArS1 = superelliptic_function(C_super, y*x)
fArS2 = superelliptic_function(C_super, y*x^2)
AS1 = as_cover(C_super, [fArS1, fArS2], prec=1000)
omega = as_form(AS1, 1/y)
print(omega.expansion_at_infty().valuation()==AS1.exponent_of_different())