def laurent_analytic_part(series):
    F = base_ring(parent(series))
    Ft.<t> = LaurentSeriesRing(F)
    result = Ft(0)
    for i in series.exponents():
        if i<0:
            result += series[i]*t^i
    return result

def laurent_integral(series):
    F = base_ring(parent(series))
    Ft.<t> = LaurentSeriesRing(F)
    result = Ft(0)
    for i in series.exponents():
        result += series[i]*(t^i).integral()
    return result